%{

#include "lex.h"

#ifdef FLEX

#undef YY_INPUT
#undef unput
#undef ECHO
#undef yywrap

#define YY_INPUT(buf,result,max_size) (result = (*lex_source == NULL) ? YY_NULL : (buf[0]=*lex_source++,1))
#define unput(c) (*lex_source--)
#define ECHO
#define yywrap() 1

#else

#undef input
#undef unput
#undef output
#undef yywrap

#define input() (*lex_source++)
#define unput(c) (*lex_source--)
#define output(c)
#define yywrap() 1

#endif

char *lex_source;
%}
%e 1100
%p 3000
%%
#			return(FMCOMMENT);
set 			return(FMSET);
load			return(FMLOAD);
verbose			return(FMVERBOSE);
target			return(FMTARGET);
password		return(FMPASSWORD);
network			return(FMNETWORK);
networks                return(FMNETWORKS);
classes			return(FMCLASSES);
show			return(FMSHOW);
host			return(FMHOST);
class			return(FMCLASS);
allow			return(FMALLOW);
reject			return(FMREJECT);
query			return(FMQUERY);
stats			return(FMSTATS);
upload			return(FMUPLOAD);
write			return(FMWRITE);
quit			return(FMQUIT);
clear			return(FMCLEAR);
reset			return(FMRESET);
release			return(FMRELEASE);
reboot 			return(FMREBOOT);
newpwd			return(FMNEWPWD);
retries			return(FMRETRIES);
tables			return(FMTABLES);
timeout			return(FMTIMEOUT);
\?                      return(FMHELP);
!			return(FMSHELL);
help                    return(FMHELP);
.			return(UNKNOWN);
%%
int tokenize(char *string)
{
    int result;

    if (string == (char *) NULL || *string == '\0') 
	return EMPTY;

    lex_source = string;

    result = yylex();

#ifdef FLEX
    YY_FLUSH_BUFFER;
#endif

    return result;
}
